/** \file
 * One-stop include file for libfactory++
 *
 * \author Martin F. Krafft <krafft@ailab.ch>
 * \date $Date: 2004/06/01 12:05:39 $
 * \version $Revision: 1.5 $
 *
 */

/**
 *
 *
 * libfactory++ is a C++ template framework for run-time dynamic type
 * instantiation.
 */
namespace Factory {
        // this is here for doxygen's benefit.
} 

#include <factory++/builder.hpp>
#include <factory++/constructor.hpp>
#include <factory++/destructor.hpp>
#include <factory++/factory.hpp>
#include <factory++/registrar.hpp>
#include <factory++/request.hpp>

#include <factory++/macros.hpp>

/* COPYRIGHT --
 *
 * This file is part of libfactory++, a C++ template factory framework.
 * libfactory++ is (c) 2004 Martin F. Krafft <krafft@ailab.ch>
 * and distributed under the terms of the Artistic Licence.
 * See the ./COPYING file in the source tree root for more information.
 *
 * THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES
 * OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */
